#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "pgm.h"
#include "evaluate.h"

int num_el;

main(int argc, char *argv[])
{
  FILE *in, *out;
  int i, j, count_i, count_j;
  double **avg, diff, total_avg;
  int target_x, target_y, index;
  int border, sep, boundry;
  char im_name[20];
  int max, width, height;
  unsigned char *image;

/*
  num_el=12;
  border=16;
  sep=0;
*/

  if (argc == 1)
  {
    printf("FILE FORMAT: image border separation num_elements ");
    printf("target_x target_y index\n");
    printf("separation: one pixel on each side of element is ");
    printf("considered not separated\n");
    printf("num_elements: number in a single row\n");
    exit(0);
  }

  in = fopen(argv[1], "r");
  out = fopen(argv[2], "w");

  while(!feof(in))
  {

    fscanf(in, "%s %d %d %d %d %d %d\n", im_name, &border, &sep, 
		&num_el, &target_x, &target_y, &index);
    num_el-=2;

/*
    fscanf(in, "%s %d %d %d\n", im_name, &target_x, &target_y, &index);
*/

    max = read_pgm(im_name, &image, &width, &height);

    avg = (double **) malloc(num_el*sizeof(double *));
    for(i=0; i<num_el; i++)
      avg[i] = (double *) malloc(num_el*sizeof(double));

    count_i=0;
    boundry = border/4 + 3*sep/8 + ELSIZE;
    printf("boundry=%d\n", boundry);
    for(i=boundry; i<IMSIZE-boundry; i+=(ELSIZE+sep/4))
    {
      count_j=0;
      for(j=boundry; j<IMSIZE-boundry; j+=(ELSIZE+sep/4))
	avg[count_i][count_j++] = average(image, i, j, width);
      count_i++;
    }

    diff = difference(avg, target_x-1, target_y-1, &total_avg);
    printf("%g\n", diff);

    fprintf(out, "%d\t%g\t%g\t%g\t%d\n", index, diff,
		avg[target_y-1][target_x-1], total_avg, num_el);
    free(image);
/*
    for(i=0; i<num_el; i++)
    {
      for (j=0; j<num_el; j++)
	printf("%g ", avg[i][j]);
      printf("\n");
    }
    printf("\n\n");
*/
    for(i=0; i<num_el; i++)
      free(avg[i]);
    free(avg);

  }

  fclose(in);
  fclose(out);
}

double average(unsigned char *image, int x, int y, int width)
{
  int i, j;
  double total=0.0;

  for(i=0; i<ELSIZE; i++)
    for(j=0; j<ELSIZE; j++)
    {
/*      printf("row: %d, col: %d, value:%d\n", i+x, j+y,
		image[(i+x)*width+(j+y)]);*/
      total+=image[(i+x)*width+j+y];
    }
  return total/(ELSIZE*ELSIZE);
}

double difference(double **avg, int x, int y, double *total_avg)
{
  int i, j;
  double total=0.0;
  int count=0;

  for(i=1; i<num_el-1; i++)
  {
    for(j=1; j<num_el-1; j++)
      {
	total+=avg[i][j];
      /*printf("i=%d j=%d, avg=%g\n", i, j, avg[i][j]);*/
      }
  }

/*
  printf("total=%g ",total); 
*/
  total-=avg[y][x];

  *total_avg=total/((num_el-2)*(num_el-2)-1);
/*
  printf("total dist=%g target=%g total_avg=%g\n",total, avg[y][x],
		*total_avg); 
*/
  printf("target=%g, avg = %g, ratio=%g\t", avg[y][x], (*total_avg), avg[y][x]/(*total_avg));
  return avg[y][x]/(*total_avg);
}
